/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is Mozilla Communicator client code,
 * released March 31, 1998.
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation.  Portions created by Netscape are
 * Copyright (C) 2000 Netscape Communications Corporation. All
 * Rights Reserved.
 */
// update menu items that rely on focus
function goUpdateGlobalEditMenuItems() {
	goUpdateCommand('cmd_undo');
	goUpdateCommand('cmd_redo');
	goUpdateCommand('cmd_cut');
	goUpdateCommand('cmd_copy');
	goUpdateCommand('cmd_paste');
	goUpdateCommand('cmd_pasteNoFormatting');
	goUpdateCommand('cmd_selectAll');
	goUpdateCommand('cmd_delete');
}

// update menu items that rely on the current selection
function goUpdateSelectEditMenuItems() {
	goUpdateCommand('cmd_cut');
	goUpdateCommand('cmd_copy');
	goUpdateCommand('cmd_delete');
	goUpdateCommand('cmd_selectAll');
}

// update menu items that relate to undo/redo
function goUpdateUndoEditMenuItems() {
	goUpdateCommand('cmd_undo');
	goUpdateCommand('cmd_redo');
}

// update menu items that depend on clipboard contents
function goUpdatePasteMenuItems() {
	goUpdateCommand('cmd_paste');
	goUpdateCommand('cmd_pasteNoFormatting');
}


function DSFillContextMenu(event, contextMenuNode) {
	if ( event.target != contextMenuNode )
		return;

	// Loop through all children to hide disabled items
	var children = contextMenuNode.childNodes;
	if (children) {
		var count = children.length;
		for (var i = 0; i < count; i++)
			HideDisabledItem(children[i]);
	}

	// Remove separators if all items in immediate group above are hidden
	// A bit complicated to account if multiple groups are completely hidden!
	var haveUndo =
		IsMenuItemShowing("cMenu_undo") ||
		IsMenuItemShowing("cMenu_redo");

	var haveEdit =
		IsMenuItemShowing("cMenu_cut")   ||
		IsMenuItemShowing("cMenu_copy")  ||
		IsMenuItemShowing("cMenu_paste") ||
		IsMenuItemShowing("cMenu_pasteNoFormatting") ||
		IsMenuItemShowing("cMenu_delete");

	var haveSpelling =
		IsMenuItemShowing("cMenu_spell");

  ShowMenuItem("undoredo-separator", haveUndo && haveEdit);

  ShowMenuItem("edit-separator", haveEdit || haveUndo);

  ShowMenuItem("spell-separator", haveSpelling);
	// Note: Item "cMenu_selectAll" is ALWAYS enabled so there is no seperator named after
	// selectAll. Instead it is named after the next item which may or may not be enabled
}

function IsItemOrCommandEnabled(item) {
	var command = item.getAttribute("command");
	if (command) {
	// If possible, query the command controller directly
		var controller = document.commandDispatcher.getControllerForCommand(command);
		if (controller)
		return controller.isCommandEnabled(command);
	}

	// Fall back on the inefficient observed disabled attribute
	return item.getAttribute("disabled") != "true";
}

function HideDisabledItem(item) {
	item.hidden = !IsItemOrCommandEnabled(item);
}

function ShowMenuItem(id, showItem) {
	var item = document.getElementById(id);
	if (item && !showItem) {
		item.hidden = true;
	}
}

function IsMenuItemShowing(menuID) {
	var item = document.getElementById(menuID);
	if (item)
		return !item.hidden;

	return false;
}
